class ApocEnemyController extends AIController;

var ApocNavPointInterface Destination;
var ApocNavPointInterface PreviousDestination;
/** Whether the current target is directly reachable, last we checked */
var bool CurrentTargetIsReachable;

/** Holds the team number */
var int Team;

var transient float LastObstructionJumpTime;
var transient int ObstructionJumpCount;
var transient int TardCounter;
var transient Vector LastPawnPos;
var int ObstructionDir;

var name CurrentTask;
var name NextTask;
var int TimeCurrentTask;
var float EstTimeCurrentTask;
var float EstTimeNextTask;


DefaultProperties
{
	NavigationHandleClass=class'NavigationHandle';
	ObstructionDir = 1;
	bIsPlayer = true;
	bSeeFriendly = true;
	
}

state Dying
{
	event BeginState(Name PreviousState)
	{
		ClearAllTimers();
		StopLatentExecution();
	}
}

event PostBeginPlay()
{
	Super.PostBeginPlay();
	SetTimer(1.0f, true, 'AlterStats');
	SetTimer(5.0f, true, 'DecideWhatToDoNext');

	//TODO Remy: Legg til i riktig team.
	//local TeamInfo LocalTeamInfo;
	//if (PlayerReplicationInfo.Team == none)
	//{
	//	`log(name @ "FUUUUUUUUCK!!!! No Team");
	//	LocalTeamInfo = Spawn(class'TeamInfo');
	//}
	//else
	//{
	//	`log(name @ "GOTZTeamInfo:" @ PlayerReplicationInfo.Team);
	//}

	//if (PlayerReplicationInfo.Team == none)
	//{
	//	`log(name @ "FUUUUUUUUCK!!!! Still no Team");
	//}
	//else
	//{
	//	`log(name @ "GOTZ TeamInfo:" @ PlayerReplicationInfo.Team);
	//}
	//PlayerReplicationInfo.Team.GetTeamNum();

	//SetTeam(1);
	//`log(name @ "NEW TEAM:" @ GetTeamNum() @ "PlayerReplicationInfo Says:" @ PlayerReplicationInfo.GetTeamNum() @ "Team Says:" @ PlayerReplicationInfo.Team.GetTeamNum());
}

event SeePlayer(Pawn Seen)
{
	super.SeePlayer(Seen);
}

event EnemyNotVisible()
{
	super.EnemyNotVisible();
}

/**
 * Called Every X seconds to change an enemy's stats.
 */
function AlterStats()
{
	TimeCurrentTask++;
}

/**
 * Called every X seconds to set NextTask. Gathers some relevant status and push the state Deciding.
 */
function DecideWhatToDoNext()
{
	//Or at least is supposed to once the Deciding state is finished to a point of testing.
	//PushState('Deciding');

	`log("ApocEnemytController:" @ "DecideWhatToDoNext() is running and" @ Pawn.Name @ "is currently" @ CurrentTask @ "Next task is" @ NextTask);
	// Move this estimation out to the state poped events?
}

/**
 * Refreshes the task variables. Should be called upon transition to a new task state.
 */
function RefreshTasks()
{
	CurrentTask = GetStateName();
	TimeCurrentTask = 0;
}

event vector GeneratePathToActor( ApocNavPointInterface Goal, optional float WithinDistance, optional bool bAllowPartialPath )
{
	local vector NextDest;
	local Vector eyePos;
	local bool samePos;
	local float deltaDist;

	FlushPersistentDebugLines();

	deltaDist = VSize(Pawn.Location - LastPawnPos);
	samePos = ( deltaDist < 0.0001f);

	if(samePos)
	{
		TardCounter++;
		`log(name @ Pawn.Name @ "increased tardness to" @ TardCounter);
	}
	else
	{
		TardCounter = 0;
	}

	NextDest = Goal.GetNavPoint();
	
	if(Enemy == none && self.IsWithinLineOfSight(Goal.GetNavPoint()) && (TardCounter < 2))
	{
		//`log(name @ Pawn.Name @ "is in a straight line of it's goal and deltaDist is:" @ deltaDist);
		LastPawnPos = Pawn.Location;
		return NextDest;
	}
	//else
	//{
	//	`log(name @ Pawn.Name @ "is currently retarded");
	//}

	if ( NavigationHandle == None )
	{
		InitNavigationHandle();
	}
	// Clear cache and constraints (ignore recycling for the moment)
	NavigationHandle.PathConstraintList = none;
	NavigationHandle.PathGoalList = none;




	if (Enemy != none)
	{
		//class'NavMeshPath_BiasAgainstPolysWithinDistanceOfLocations'.static.BiasAgainstPolysWithinDistanceOfLocations(NavigationHandle, Enemy.Location, Enemy.Rotation, ApocPawn(Pawn).AVOID_DISTANCE, VectorList);
		//class'NavMeshPath_MinDistBetweenSpecsOfType'.static.EnforceMinDist(NavigationHandle, ApocPawn(Pawn).AVOID_DISTANCE, NAVEDGE_Normal, Enemy.Location);
		class'NavMeshPath_WithinDistanceEnvelope'.static.StayWithinEnvelopeToLoc(NavigationHandle, Enemy.Location, 1000000000.0f, ApocPawn(Pawn).AVOID_DISTANCE, true, 3000.0f, true);
	}
	else
	{
		class'NavMeshPath_Toward'.static.TowardPoint( NavigationHandle, Goal.GetNavPoint());
	}

	class'NavMeshGoal_At'.static.AtLocation( NavigationHandle, Goal.GetNavPoint(), WithinDistance, true);

	if ( NavigationHandle.FindPath() )
	{
		if (!NavigationHandle.GetNextMoveLocation(NextDest, 120))
		{
			`log(name @ Pawn.Name @ "Found path but GetNextMoveLocation failed hard. He so want to run to (0, 0, 0) but we won't let'im");
			NextDest = Pawn.Location;
		}
	}
	else
	{
		`log(name @ Pawn.Name @ "found no path to" @ Goal.Name);
	}

	// TODO fjern debug lines
	eyePos = Pawn.Location;
	eyePos.Z += Pawn.EyeHeight;
	//DrawDebugLine(eyePos, NextDest, 255, 0, 0, true);
	//NavigationHandle.DrawPathCache(vect(0, 0, 0), true, MakeColor(0, 0, 255, 255));

	NavigationHandle.ClearConstraints();
	LastPawnPos = Pawn.Location;
	return NextDest;
}

function bool IsWithinLineOfSight(Vector other)
{
	local Vector hitLoc, hitNorm, eyePos;
	eyePos = Pawn.Location;
	eyePos.Z += Pawn.EyeHeight;
	return Trace(hitLoc,hitNorm,other,eyePos,true) == none;
}

function bool ActorIsWithinLineOfSight(Actor Other)
{
	local Vector hitLoc, hitNorm, eyePos;
	local bool IsSeen;
	local Actor SeenActor;

	eyePos = Pawn.Location;
	eyePos.Z += Pawn.EyeHeight;

	SeenActor = Trace(hitLoc, hitNorm, Other.Location, eyePos, true);
//	`log(name @ Pawn.Name @ "sees" @ SeenActor.Name);

	IsSeen = SeenActor == Other;
//	`log(name @ Pawn.Name @ "sees" @ Other.Name $ "?" @ IsSeen);
	return IsSeen;
}

function InitNavigationHandle()
{
	if( NavigationHandleClass != None && NavigationHandle == none ){
		NavigationHandle = new(self) NavigationHandleClass;
		//NavigationHandle.bUltraVerbosePathDebugging = true;
		//NavigationHandle.bDebugConstraintsAndGoalEvals = true;
	}
}


function Actor FindNearestTargetOfType(name Type)
{
	local array<Actor> tempArray;
	local Actor tempActor;
	local float currentNearest;
	local Actor currentNearestActor;
	local float tempDist;
	
	tempArray = FindTargetsOfType(Type);
	currentNearest = MaxInt;

	foreach tempArray(tempActor)
	{
		tempDist = VSize(tempActor.Location - Pawn.Location);
		if(tempDist < currentNearest)
		{
			currentNearest = tempDist;
			currentNearestActor = tempActor;
		}
	}
	return currentNearestActor;
}

function array<Actor> FindTargetsOfType(name Type)
{
	local Actor TempTarget;
	local array<Actor> TempArray;

	foreach main(WorldInfo.Game).TargetableActors(TempTarget)
	{
		if(TempTarget.IsA(Type))
		{
			TempArray.AddItem(TempTarget);
		}
	}
	return TempArray;
}

function ObstructionJump(Vector jumpForwardDir, Vector jumpSideDir)
{
	//ObstructionJumpCount++;
	ObstructionDir*=-1;
	//LastObstructionJumpTime = WorldInfo.TimeSeconds;
	//`log(name @ self @ " Obstruction jumping: " @ Pawn.Physics);
	if(Pawn.Physics == PHYS_Walking)
	{
		Pawn.Velocity += ((jumpForwardDir + ObstructionDir*jumpSideDir)>>Pawn.Rotation);
		//`log(name @ "Jumping to get over obstruction... " @ Pawn.Velocity);
	}

	Pawn.DoJump(false);
}
