class ApocField extends ApocStaticActor
placeable;
var(Apocalypse) int Rows;
var(Apocalypse) int Cols;
var(Apocalypse) array<ApocFieldUnit> Units;
var(Apocalypse) ApocFieldUnit Afu;

DefaultProperties
{
	Rows = 4
	Cols = 4
}

event PreBeginPlay()
{
	super.PreBeginPlay();
	SetNavPoints();
	SpawnFieldUnits();

}

function SpawnFieldUnits()
{
	local int x, maxX;
	local int y, maxY;
	local Vector currentPos;
	local Vector rot;
	local Rotator uRot;
	local Vector traceStart;
	local Vector traceEnd;
	local Vector resultNormal;
	
	maxX = DrawScale3D.X / 100;
	maxY = DrawScale3D.Y / 100;
	for(y = 0; y < maxY; y++)
	{
		for(x  = 0; x < maxX; x++)
		{
			uRot = Rotation;
			rot = Vector(uRot);
			currentPos = Location;
			
			currentPos += rot * ((float(x) * 100.0) - (DrawScale3D.X / 2) + 50);
			uRot.Yaw += (16384);
			rot = Vector(uRot);
			currentPos += rot * ((float(y) * 100.0) - (DrawScale3D.Y / 2) + 50);
			//Shoot trace into the ground y'all
			traceStart = currentPos;
			traceStart.Z += 1000;
			traceEnd = currentPos;
			traceEnd.Z -= 1000;
			Trace(currentPos, rot, traceEnd, traceStart);
			uRot = Rotation;
			uRot.Yaw += Rand(65536);
			Spawn(Afu.Class, self, , currentPos, uRot, Afu, true);
			Units.AddItem(Afu);
		}
	}
	SetHidden(true);
}

event Touch (Actor Other, PrimitiveComponent OtherComp, Object.Vector HitLocation, Object.Vector HitNormal)
{
	super.Touch(Other, OtherComp, HitLocation, HitNormal);
	//`log(Other.Name @ "is touching" @ Name @ "in improper places" @ HitLocation);
}


function SetNavPoints()
{
	// TODO Change this from placeholder values
	local Vector rot;
	local Vector pos;
	local Rotator uRot;
	local NavPoint np;
	
	uRot.Yaw = (16384 * 1);
	uRot += Rotation;
	pos = Location;
	
	rot = Vector(uRot);
	pos = pos + (rot * 100);

	pos.Z += 50;
	np.isOccupied = false;
	np.navPoint = pos;
	
	NavPoints.AddItem(np);

	uRot.Pitch = 0;
	uRot.Roll = 0;
	uRot.Yaw = (16384 * 3);
	uRot += Rotation;
	pos = Location;

	rot = Vector(uRot);
	pos = pos + (rot * 100);

	pos.Z += 50;
	np.isOccupied = false;
	np.navPoint = pos;
	
	NavPoints.AddItem(np);

}

function OccupyNavPoint(ApocPawn occupier, Vector navPointPos, bool isOccupying)
{
	local int i;

	for(i = 0; i < NavPoints.Length; i++)
	{
		if(NavPoints[i].navPoint == navPointPos)
		{
			NavPoints[i].isOccupied = isOccupying;
			if(isOccupying)
				`log(occupier.Name @ "is occupying " @ navPointPos);
			else
				`log(occupier.Name @ "is releasing " @ navPointPos);
			break;
		}
	}
}

// TODO Change this from placeholder values
event Tick(float DeltaTime)
{
	//DrawDebugPoint(GetNavPointAt(0) ,30, MakeLinearColor(255, 255, 0, 128), false);
	//DrawDebugPoint(GetNavPointAt(1) ,30, MakeLinearColor(0, 255, 255, 128), false);
}
