class ApocFieldUnit extends InteractiveFoliageActor;
var(Apocalypse) int numOfPlants;
var(Apocalypse) DynamicLightEnvironmentComponent ApoLightEnvironment;
var(Apocalypse) CylinderComponent ApoCC;
var(Apocalypse) float CollisionRadius;

simulated event PreBeginPlay()
{
	CollisionComponent = ApoCC;
	StaticMeshComponent.SetLightEnvironment(ApoLightEnvironment); 
}

DefaultProperties
{
	numOfPlants = 3;
	bStatic = false;
	bNoDelete = false;
	CollisionRadius = 40.0;

	Begin Object Class=DynamicLightEnvironmentComponent Name=MyLightEnvironment
		ModShadowFadeoutTime=0.25
		MinTimeBetweenFullUpdates=0.2
		AmbientGlow=(R=.01,G=.01,B=.01,A=1)
		AmbientShadowColor=(R=0.15,G=0.15,B=0.15)
		LightShadowMode=LightShadow_ModulateBetter
		ShadowFilterQuality=SFQ_High
		bSynthesizeSHLight=TRUE
	End Object
	Components.Add(MyLightEnvironment)
	ApoLightEnvironment=MyLightEnvironment;

	Begin Object Class=CylinderComponent Name=MyCollisionComponent
		CollisionRadius = 40f;
	End Object
	Components.Add(MyCollisionComponent)
	ApoCC = MyCollisionComponent;
}

