class ApocPeasantController extends ApocEnemyController;


const INTERACTION_DISTANCE = 60.0f;

// Stat changes per unit of time in an action. Should probably be moved elsewhere
const ALTER_CORRUPTION_CHURCH   = -50.0f;
const ALTER_HEALTH_CHURCH   	=  50;
const ALTER_HEALTH_HOME         =  20;
const ALTER_HUNGER_CHURCH       = -50.0f;
const ALTER_HUNGER_HOME	        = -20.0f;
const ALTER_HUNGER_TICK	        =   1.0f;
const ALTER_THIRST_CHURCH       = -50.0f;
const ALTER_THIRST_HOME	        = -20.0f;
const ALTER_THIRST_TICK 	    =   1.0f;

//Stat thresholds for ApocPeasant(Pawn)
const DANGEROUS_HEALTH_THRESHOLD  = 30;
const CRITICAL_HUNGER_THRESHOLD   = 85.0f;
const DANGEROUS_HUNGER_THRESHOLD  = 70.0f;
const CRITICAL_THIRST_THRESHOLD   = 85.0f;
const DANGEROUS_THIRST_THRESHOLD  = 70.0f;

//Stat thresholds for ApocPeasant(Pawn).Home
const LOW_FOOD_THRESHOLD  = 5;
const LOW_WATER_THRESHOLD = 5;

// TODO rename this
// Slingringsmonnet for estimates. The actual value used will be RandRange(SLINGRINGSMONN, 2*SLINGRINGSMONN).
const SLINGRINGSMONN = 2.0f;

var(ApocalypsePeasantController) int AttendMassChanceBase;
var(ApocalypsePeasantController) int GatherFoodChanceBase;
var(ApocalypsePeasantController) int GatherWaterChanceBase;
var(ApocalypsePeasantController) int GoHomeChanceBase;
var(ApocalypsePeasantController) int StrollingChanceBase;

var bool HorsemenSpotted;
var Vector NextDest;
var float EstTimeUntilDeath;

DefaultProperties
{
	TotalTime = 1;
	HorsemenSpotted = false;

	AttendMassChanceBase = 100;
	GatherFoodChanceBase = 100;
	GatherWaterChanceBase = 100;
	GoHomeChanceBase = 100;
	StrollingChanceBase = 100;
}

event PostBeginPlay()
{
	super.PostBeginPlay();
	`log(name @ ":" @ self.Name@" Online");
}

event SeePlayer(Pawn Seen)
{
	super.SeePlayer(Seen);
	

	if(Pawn == none)
	{
		`log(name @ ":" @ name @ "is mah controller, but you can call me nobody");
	}
	else if(Seen == none)
	{
		`log(name @ ":" @ Pawn.Name @ "What the fuck I see someone, but I don't see 'em?");
	}
	else if(Pawn.IsInState('Dying'))
	{
		`log(name @ ":" @ Pawn.Name @ "Aaaaaaw hell naw, I ain't dead yet. Oh wait I am.");
	}
	else if(Seen.IsInState('Dying'))
	{
		`log(name @ ":" @ Pawn.Name @ "Dead nigga spotted yo. I'ma pourin one out fo' ma homie" @ Seen.Name);
	}
	else
	{
		if (ActorIsWithinLineOfSight(Seen))
		{
			if (Seen.IsA('ApocPlayer'))
			{
				Enemy = Seen;
				if (!IsInState('RunAway', true))
				{
					PushState('RunAway');
				}
			}
		}
	}
}

event EnemyNotVisible()
{
	super.EnemyNotVisible();
}

/**
 * Called Every X seconds to change a peasant's hunger and thirst states
 */
function AlterStats()
{
	local ApocPeasant Peasant;

	super.AlterStats();

	Peasant = ApocPeasant(Pawn);
	Peasant.AlterThirst(ALTER_THIRST_TICK);
	Peasant.AlterHunger(ALTER_HUNGER_TICK);

	//`log(name @ ":" @ ApocPeasant(Pawn).StatsToString());
}

/**
 * Called every X seconds to set NextTask. Gathers some relevant status and push the state Deciding.
 */
function DecideWhatToDoNext()
{
	local name EvalTask, GatherTask;
	local float EstTimeEvalTask, EstTimeHome, EstTimeMass,
		LowStat, TTStatLow, DangerousStatThreshold, CriticalStatThreshold;
	local int StockThreshold,
		LowStockThreshold, HomeStock, RandomChoice,
		AttendMassChanceFin, GatherFoodChanceFin, GatherWaterChanceFin, GoHomeChanceFin, StrollingChanceFin, TotalChanceFin;


	super.DecideWhatToDoNext();

	EstTimeCurrentTask = EstimateTask(CurrentTask, false);
	EstTimeNextTask = EstimateTask(NextTask, false);
	EstTimeHome = EstimateTask('GoHome', false);
	EstTimeMass = EstimateTask('AttendMass', false);

	// Move this estimation out to the state poped events?
	EstTimeUntilDeath = ApocPeasant(Pawn).EstimatedTimeLeft();


	`log(name @ ":" @ "Deciding start:" @ ApocPeasant(Pawn).StatsToString());
	if (Pawn.Health < DANGEROUS_HEALTH_THRESHOLD)// Health is dangerously low.
	{
		//`log(name @ "/Decision:" @ Pawn.Name @ "Health Low");
		EvalTask = 'GoHome';
		EstTimeEvalTask = EstTimeHome;
		if (EstTimeMass < EstTimeEvalTask && EstTimeMass + RandRange(SLINGRINGSMONN, 2*SLINGRINGSMONN) < EstTimeUntilDeath)// Check to see if mass will be happening soon.
		{
			//`log(name @ "/Decision:" @ Pawn.Name @ "Mass soon, will go there to replenish");
			EvalTask = 'AttendMass';
		}

		if (CurrentTask != EvalTask && !IsInState('InsideBuilding'))// Forces peasant to go somewhere he can heal up.
		{
			`log(name @ "/Decision:" @ Pawn.Name @ "Forces peasant to go somewhere and heal up");
			NextTask = EvalTask;
			PopState(true);
			GotoState(NextTask, 'Begin', true, false);
		}
	}
	else
	{
		//`log(name @ "/Decision:" @ Pawn.Name @ "Health not Low any other criticals?");
		// Sets the current most important stat to check against it's critical value.
		if (ApocPeasant(Pawn).Thirst > ApocPeasant(Pawn).Hunger
			|| ApocPeasant(Pawn).Thirst > CRITICAL_THIRST_THRESHOLD
			|| (ApocPeasant(Pawn).Thirst > DANGEROUS_THIRST_THRESHOLD && !(ApocPeasant(Pawn).Hunger > CRITICAL_HUNGER_THRESHOLD)))
		{
			//`log(name @ "/Decision:" @ Pawn.Name @ "Thirst is lowest");
			LowStat = ApocPeasant(Pawn).Thirst;
			DangerousStatThreshold = DANGEROUS_THIRST_THRESHOLD;
			CriticalStatThreshold = CRITICAL_THIRST_THRESHOLD;
			LowStockThreshold = LOW_WATER_THRESHOLD;
			HomeStock = ApocPeasant(Pawn).Home.Water;
			TTStatLow = ApocPeasant(Pawn).TimeTilThirsty();
			GatherTask = 'GatherWater';
		}
		else
		{
			//`log(name @ "/Decision:" @ Pawn.Name @ "Hunger is lowest");
			LowStat = ApocPeasant(Pawn).Hunger;
			DangerousStatThreshold = DANGEROUS_HUNGER_THRESHOLD;
			CriticalStatThreshold = CRITICAL_HUNGER_THRESHOLD;
			LowStockThreshold = LOW_FOOD_THRESHOLD;
			HomeStock = ApocPeasant(Pawn).Home.Food;
			TTStatLow = ApocPeasant(Pawn).TimeTilHungry();
			GatherTask = 'GatherFood';
		}

		if (LowStat > DangerousStatThreshold)// Stat is dangerously high.
		{
			if (LowStat > CriticalStatThreshold)// Stat is critically high.
			{
				//`log(name @ "/Decision:" @ Pawn.Name @ "Stat conected to" @ GatherTask @ "is Critically low");
				StockThreshold = 0;
			}
			else
			{
				//`log(name @ "/Decision:" @ Pawn.Name @ "Stat conected to" @ GatherTask @ "is Dangerously low");
				StockThreshold = LowStockThreshold;
			}

			if (HomeStock > StockThreshold)// There is enough at home to bother replenishing stat.
			{
				//`log(name @ "/Decision:" @ Pawn.Name @ "Don't have enough at home");
				EvalTask = 'GoHome';
				EstTimeEvalTask = EstTimeHome;
				//`log(name @ "/Decision:" @ Pawn.Name @ "Next task is" @ NextTask);
				if (EstTimeMass < EstTimeEvalTask)// Check to see if mass will be happening soon.
				{
					//`log(name @ "/Decision:" @ Pawn.Name @ "Mass soon, will go there to replenish");
					EvalTask = 'AttendMass';
					EstTimeEvalTask = EstTimeMass;
				}

				NextTask = EvalTask;
				EstTimeNextTask = EstTimeEvalTask;
				`log(name @ "/Decision:" @ Pawn.Name @ "Next task is" @ NextTask);
				if ((CurrentTask != EvalTask)
					&& (EstTimeCurrentTask + EstTimeNextTask + RandRange(SLINGRINGSMONN, 2*SLINGRINGSMONN) >= TTStatLow)
					&& !IsInState('InsideBuilding'))
				{
					`log(name @ "/Decision:" @ Pawn.Name @ "Forces peasant to go somewhere and replenish stats");
					// Waiting for current task takes too long. Forcing state change.
					EvalTask = CurrentTask;
					CurrentTask = NextTask;
					NextTask = EvalTask;
					GotoState(NextTask, 'Begin', true, false);
				}
			}
			else// Not enough at home, need to gather more
			{
				//`log(name @ "/Decision:" @ Pawn.Name @ "Not enough stock at home, need to gather");
				EvalTask = GatherTask;
				EstTimeEvalTask = EstimateTask(EvalTask, true);
				//`log(name @ "/Decision:" @ Pawn.Name @ "EvalTask is" @ EvalTask);
				if (EstTimeMass < EstTimeEvalTask)// Check to see if mass will be happening soon.
				{
					//`log(name @ "/Decision:" @ Pawn.Name @ "Mass soon, will go there to replenish");
					EvalTask = 'AttendMass';
					EstTimeEvalTask = EstTimeMass;
				}
				//`log(name @ "/Decision:" @ Pawn.Name @ "EvalTask is" @ EvalTask);

				NextTask = EvalTask;
				EstTimeNextTask = EstTimeEvalTask;
				`log(name @ "/Decision:" @ Pawn.Name @ "Next task is" @ NextTask);
				if ((CurrentTask != EvalTask)
					&& (EstTimeCurrentTask + EstTimeNextTask + RandRange(SLINGRINGSMONN, 2*SLINGRINGSMONN) >= TTStatLow)
					&& !IsInState('InsideBuilding'))
				{
					`log(name @ "/Decision:" @ Pawn.Name @ "Forces peasant to go somewhere and gather resources");
					// Waiting for current task takes too long. Forcing state change.
					EvalTask = CurrentTask;
					CurrentTask = NextTask;
					NextTask = EvalTask;
					GotoState(NextTask, 'Begin', true, false);
				}
			}
		}
		else if (ApocPeasant(Pawn).Home.Water < LOW_WATER_THRESHOLD)// Low on water at home
		{
			`log(name @ "/Decision:" @ Pawn.Name @ "Low on water at home");
			EvalTask = 'GatherWater';// WATER/THIRST VAR
			NextTask = EvalTask;
		}
		else if (ApocPeasant(Pawn).Home.Food < LOW_FOOD_THRESHOLD)// Low on food at home
		{
			`log(name @ "/Decision:" @ Pawn.Name @ "Low on food at home");
			EvalTask = 'GatherFood';// WATER/THIRST VAR
			NextTask = EvalTask;
		}
		else
		{
			AttendMassChanceFin = (AttendMassChanceBase - ApocPeasant(Pawn).Corruption) * (1/EstTimeMass);
			GatherFoodChanceFin = GatherFoodChanceBase + (ApocPeasant(Pawn).Hunger * ApocPeasant(Pawn).HungerMultiplier) / ApocPeasant(Pawn).Home.Water;
			GatherWaterChanceFin = GatherWaterChanceBase + (ApocPeasant(Pawn).Thirst * ApocPeasant(Pawn).ThirstMultiplier) / ApocPeasant(Pawn).Home.Water;
			GoHomeChanceFin = GoHomeChanceBase +  Max(ApocPeasant(Pawn).Hunger * ApocPeasant(Pawn).HungerMultiplier, ApocPeasant(Pawn).Thirst * ApocPeasant(Pawn).ThirstMultiplier);
			StrollingChanceFin = StrollingChanceBase + Rand(StrollingChanceBase);

			TotalChanceFin = AttendMassChanceFin + GatherFoodChanceFin + GatherWaterChanceFin + GoHomeChanceFin + StrollingChanceFin;
			`log(name @ "/Decision:" @ Pawn.Name @ "Chances for Mass:" @ AttendMassChanceFin/float(TotalChanceFin) @ "Food:" @ GatherFoodChanceFin/float(TotalChanceFin) @ "Water:" @ GatherWaterChanceFin/float(TotalChanceFin) @ "Home:" @ GoHomeChanceFin/float(TotalChanceFin) @ "Stroll:" @ StrollingChanceFin/float(TotalChanceFin));

			RandomChoice = Rand(TotalChanceFin);
			if (RandomChoice < AttendMassChanceFin)
			{
				NextTask = 'AttendMass';
			}
			else if (RandomChoice < AttendMassChanceFin + GatherFoodChanceFin)
			{
				NextTask = 'GatherFood';
			}
			else if (RandomChoice < AttendMassChanceFin + GatherFoodChanceFin + GatherWaterChanceFin)
			{
				NextTask = 'GatherWater';
			}
			else if (RandomChoice < AttendMassChanceFin + GatherFoodChanceFin + GatherWaterChanceFin + GoHomeChanceFin)
			{
				NextTask = 'GoHome';
			}
			else
			{
				NextTask = 'Strolling';
			}

			`log(name @ "/Decision:" @ Pawn.Name @ "No emergency." @ NextTask @ "next.");
		}
	}
	//`log(name @ ":" @ "Deciding END");
}

/**
 * Estimates the time a task takes.
 * 
 * @param Task - The Task to be estimated.
 * 
 * @param GoHomeAfter - If the Peasant should go home afterwards even if the task does not require it.
 */
function float EstimateTask(name Task, bool GoHomeAfter)
{
	local int ActionEstimate;
	local float TotalEstimate;
	local float PawnSpeed;
	local Vector DestLocation;
	local Vector VectDest;
	local Vector VectHome;

	ActionEstimate = 0;
	PawnSpeed = Pawn.GroundSpeed;
	DestLocation = Pawn.Location;

	// TODO Currently estimates all distances in straight line air travel. Exchange this with path iteration.
	if (Pawn.bIsWalking)
	{
		PawnSpeed = PawnSpeed * Pawn.WalkingPct;
	}
	if (Task == 'GoHome')
	{
		VectHome = ApocPeasant(Pawn).Home.GetNavPoint() - DestLocation;
	}
	else
	{
		ActionEstimate = ApocPeasant(Pawn).MaxLoad - ApocPeasant(Pawn).Load;
		switch(Task)
		{
			case 'GatherWater':// WATER/THIRST VAR
				if (ApocPeasant(Pawn).LoadType != GOODS_Water && ActionEstimate < ApocPeasant(Pawn).MaxLoad)// WATER/THIRST VAR
				{
					// Carries something else, estimating unload trip.
					TotalEstimate = EstimateTask('GoHome', false);
					// Estimates time taken from home
					// TODO Tweak denne til  kunne ta inn argument lokasjon.
					DestLocation = ApocStaticActor(FindNearestTargetOfType('ApocWell')).GetNavPoint();// WATER/THIRST VAR
					VectDest = DestLocation - ApocPeasant(Pawn).Home.GetNavPoint();
				}
				else if (0 < ActionEstimate)
				{
					// Can carry more of the same.
					DestLocation = ApocStaticActor(FindNearestTargetOfType('ApocWell')).GetNavPoint();// WATER/THIRST VAR
					VectDest = DestLocation - Pawn.Location;
				}
				VectHome = ApocPeasant(Pawn).Home.GetNavPoint() - DestLocation;
				break;
			case 'GatherFood':// WATER/THIRST VAR
				if (ApocPeasant(Pawn).LoadType != GOODS_Food && ActionEstimate < ApocPeasant(Pawn).MaxLoad)// WATER/THIRST VAR
				{
					// Carries something else, estimating unload trip.
					TotalEstimate = EstimateTask('GoHome', false);
				    // Estimates time taken from home
					// TODO Tweak denne til  kunne ta inn argument lokasjon.
					DestLocation = ApocStaticActor(FindNearestTargetOfType('ApocField')).GetNavPoint();// WATER/THIRST VAR
					VectDest = DestLocation - ApocPeasant(Pawn).Home.GetNavPoint();
				}
				else if (0 < ActionEstimate)
				{
					// Can carry more of the same.
					DestLocation = ApocStaticActor(FindNearestTargetOfType('ApocField')).GetNavPoint();// WATER/THIRST VAR
					VectDest = DestLocation - Pawn.Location;
				}
				VectHome = ApocPeasant(Pawn).Home.GetNavPoint() - DestLocation;
				break;
			case 'AttendMass':
				if (ActionEstimate < ApocPeasant(Pawn).MaxLoad)
				{
					TotalEstimate = EstimateTask('GoHome', false);
				}
				// TODO Use this instead once finished:
				// ActionEstimate = MassEveryXSeconds - TimeSinceLastMass;
				ActionEstimate = 60;
				VectDest = Pawn.Location - Pawn.Location;
				if (GoHomeAfter)
				{
					VectHome = ApocPeasant(Pawn).Home.GetNavPoint() - DestLocation;
				}
				break;
			default:
				// Strolling is here
				ActionEstimate = 0;
				DestLocation = FindRandomActor().Location;
				VectDest = DestLocation - Pawn.Location;
				if (GoHomeAfter)
				{
					VectHome = ApocPeasant(Pawn).Home.GetNavPoint() - DestLocation;
				}
				break;
		}
	}

	TotalEstimate += ActionEstimate + (VSize(VectDest) + VSize(VectHome)) / PawnSpeed;

	//`log(name @ ":" @ Pawn.Name @ "will arrive home" @ TotalEstimate @ "seconds if he starts" @ Task @ "now.");

	return TotalEstimate;
}

/**
 * Refreshes the task variables. Should be called upon transition to a new task state.
 */
function RefreshTasks()
{
	super.RefreshTasks();
	if (CurrentTask == NextTask)
	{
		NextTask = 'Strolling';
	}
}

function ApocStaticActor FindRandomActor()
{
	local array<Actor> Actors;
	Actors = FindTargetsOfType('ApocStaticActor');
	return ApocStaticActor(Actors[Rand(Actors.Length)]);
}

/**
 * Finds a home to the peasant
 */
function FindHome()
{
	local array<Actor> tempArray;
	local Actor tempActor;
	local float currentNearest;
	local Actor currentNearestActor;
	local float tempDist;
	local name Type;

	Type = 'ApocPeasantHouse';
	tempArray = FindTargetsOfType(Type);
	currentNearest = MaxInt;

	foreach tempArray(tempActor)
	{
		tempDist = VSize(tempActor.Location - Pawn.Location);
		if(tempDist < currentNearest && !ApocPeasantHouse(tempActor).IsFull)
		{
			currentNearest = tempDist;
			currentNearestActor = tempActor;
		}
	}
	`log(name @ ":" @ Pawn.Name @ "Setting home to" @ currentNearestActor.Name);
	ApocPeasantHouse(currentNearestActor).AddInhabitant(ApocPeasant(Pawn));
	ApocPeasant(Pawn).Home = ApocPeasantHouse(currentNearestActor);
}

auto state Start
{
	function SetInitTasks()
	{
		CurrentTask = 'Strolling';
		NextTask = 'Strolling';
		`log(name @ ":" @ Pawn.Name @ "START STATE, NextTask is:" @ NextTask);
	}
Begin:
	FindHome();
	Pawn.SetMovementPhysics();
	//Pawn.SetTickIsDisabled(false);
	SetInitTasks();
	GotoState(NextTask);
}

state Walking
{
	event ContinuedState()
	{
		super.ContinuedState();
		GotoState('Walking', 'Begin', true, true);
	}
	function NavigationChecks()
	{
		//`log(name @ ":" @ Pawn.Name @ "Distance" @ VSize(Destination.GetNavPoint() - Pawn.Location));
		if(VSize(Destination.GetNavPoint() - Pawn.Location) < INTERACTION_DISTANCE)
		{		
			PopState(false);
		}
	}
	function SetNextDestination()
	{
		NextDest = GeneratePathToActor(Destination, INTERACTION_DISTANCE);
	}
Begin:
	//`log(name @ ":" @ Pawn.Name @ "Walking to" @ Destination.Name);
	// Used to delay movement until our feet are solidly on the ground
	// -- helps prevent bad navmesh return values in case we're falling and are not currently on the navmesh.
	//while(Pawn.Physics != PHYS_Walking)
	//{
	//	`log(name @ ":" @ Pawn.Name @ "is falling");
	//	Sleep(0);
	//}
	WaitForLanding();
	NavigationChecks();
	SetNextDestination();
	MoveTo(NextDest);
	// TODO Fjern debug
	DrawDebugLine(Pawn.Location, NextDest, 255, 255, 0, true);
	goto 'Begin';
}

state GoHome
{
	function SetDestination()
	{
		Destination = ApocPeasant(Pawn).Home;
		//`log(name @ ":" @ Pawn.Name @ "Returning Home" @ Destination.Name @ ApocPeasant(Pawn).StatsToString());
	}
Begin:
	RefreshTasks();
	SetDestination();
	PushState('Walking');
	PushState('InsideHome');
	GotoState(NextTask);
}

state InsideBuilding
{
	ignores SeePlayer;
	event PushedState()
	{
		super.PushedState();
		Pawn.SetCollisionType(COLLIDE_NoCollision);
		//`log(name @ ":" @ Pawn.Name @ "went inside" @ ApocBuilding(Destination).Name @ Destination.Name @ "COLLISION:" @ Pawn.CollisionType);
	}
Begin:
	MoveTo(ApocBuilding(Destination).Location);
	StopLatentExecution();
	goto 'Inside';
GoOutside:
	PushState('ExitBuilding');
	PopState(false);
}

state ExitBuilding
{
	ignores SeePlayer, DecideWhatToDoNext;

	event PoppedState()
	{
		super.PoppedState();
		Pawn.SetCollisionType(COLLIDE_BlockAll);
		//`log(name @ ":" @ Pawn.Name @ "went outside" @ ApocBuilding(Destination).Name @ Destination.Name @ "COLLISION:" @ Pawn.CollisionType);
	}
Begin:
	MoveTo(Destination.GetNavPoint());
	StopLatentExecution();
	PopState(false);
}

state InsideHome extends InsideBuilding
{
	function Unload()
	{
		// Add shit to house stock here
		if (ApocPeasant(Pawn).LoadType == GOODS_Water)
		{
			ApocPeasant(Pawn).Home.AlterWater(ApocPeasant(Pawn).Load);
		}
		else if (ApocPeasant(Pawn).LoadType == GOODS_Food)
		{
			ApocPeasant(Pawn).Home.AlterFood(ApocPeasant(Pawn).Load);
		}
		ApocPeasant(Pawn).Load = 0;
		ApocPeasant(Pawn).LoadType = GOODS_None;
	}

	function HealAndEat()
	{
		local ApocPeasant Peasant;
		Peasant = ApocPeasant(Pawn);
		Peasant.HealDamage(ALTER_HEALTH_HOME, none, class'DamageType');
		if (Peasant.Home.AlterWater(-1))
		{
			Peasant.AlterThirst(ALTER_THIRST_HOME);
		}
		if (Peasant.Home.AlterFood(-1))
		{
			Peasant.AlterHunger(ALTER_HUNGER_HOME);
		}
		`log(name @ ":" @ "@home sleeping" @ Peasant.StatsToString() );
	}
Inside:
	Unload();
	sleep(1);
	goto 'ReplenishingStats';
ReplenishingStats:
	if ((Pawn.Health > (Pawn.HealthMax - ALTER_HEALTH_HOME)) &&
		(ApocPeasant(Pawn).Thirst < Abs(ALTER_THIRST_HOME) || ApocPeasant(Pawn).Home.Water <= 0) &&
		(ApocPeasant(Pawn).Hunger < Abs(ALTER_HUNGER_HOME) || ApocPeasant(Pawn).Home.Food <= 0))
	{
		goto 'GoOutside';
	}
	HealAndEat();
	Sleep(1);
	goto 'ReplenishingStats';
}

state GatherWater
{
	function SetDestination()
	{
		Destination = FindNearestTargetOfType('ApocWell');
		//`log(name @ ":" @ Pawn.Name @ "decided to gather water and targets the well" @ Destination.Name @ ApocPeasant(Pawn).StatsToString());
	}
Begin:
	RefreshTasks();
	WaitForLanding();
	SetDestination();
	PushState('Walking');
	PushState('CollectingWater');
	GotoState('GoHome');
}

state CollectingWater
{
	event PushedState()
	{
		super.PushedState();
		//`log(name @ ":" @ Pawn.Name @ "is getting water");
		StopLatentExecution();
	}
	function OcupyNavPoint()
	{
		ApocWell(Destination).OccupyNavPoint(ApocPawn(Pawn), NextDest, true); 
		ApocPeasant(Pawn).LoadType = GOODS_Water;
	}
	function CheckExitConditions()
	{
		if(ApocPeasant(Pawn).Load >= ApocPeasant(Pawn).MaxLoad)
		{
			ApocWell(Destination).OccupyNavPoint(ApocPawn(Pawn), NextDest, false); 
			PopState(false);
		}
	}
	function Collect()
	{
		ApocPeasant(Pawn).Load++;
	}
Begin:
	MoveTo(Pawn.Location);
	OcupyNavPoint();
	goto 'Gathering';
Gathering:
	CheckExitConditions();
	MoveTo(Pawn.Location);
	Collect();
	Sleep(1);
	goto 'Gathering';
}

state GatherFood
{
	function SetDestination()
	{
		Destination = FindNearestTargetOfType('ApocField');
		//`log(name @ ":" @ Pawn.Name @ "decided to gather food and targets the field" @ Destination.Name @ ApocPeasant(Pawn).StatsToString());
	}
Begin:
	RefreshTasks();
	WaitForLanding();
	SetDestination();
	PushState('Walking');
	PushState('HarvestingCrop');
	GotoState('GoHome');
}

state HarvestingCrop
{
	event PushedState()
	{
		//`log(name @ ":" @ Pawn.Name @ "is harvesting food");
		StopLatentExecution();
	}
	function OcupyNavPoint()
	{
		ApocField(Destination).OccupyNavPoint(ApocPawn(Pawn), NextDest, true); 
		ApocPeasant(Pawn).LoadType = GOODS_Food;
	}
	function CheckExitConditions()
	{
		if(ApocPeasant(Pawn).Load >= ApocPeasant(Pawn).MaxLoad)
		{
			ApocField(Destination).OccupyNavPoint(ApocPawn(Pawn), NextDest, false); 
			PopState(false);
		}
	}
	function Collect()
	{
		ApocPeasant(Pawn).Load++;
	}
Begin:
	MoveTo(Pawn.Location);
	OcupyNavPoint();
	goto 'Gathering';
Gathering:
	CheckExitConditions();
	MoveTo(Pawn.Location);
	Collect();
	Sleep(1);
	goto 'Gathering';
}

state AttendMass
{
	function SetDestination()
	{
		Destination = FindNearestTargetOfType('ApocChurch');
		//`log(name @ ":" @ Pawn.Name @ "decided to attend mass and targets the church" @ Destination.Name @ ApocPeasant(Pawn).StatsToString());
	}
Begin:
	RefreshTasks();
	WaitForLanding();
	SetDestination();
	PushState('Walking');
	PushState('InsideChurch');
	GotoState(NextTask);
}

state InsideChurch extends InsideBuilding
{
	function GetBlessing()
	{
		local ApocPeasant Peasant;
		Peasant = ApocPeasant(Pawn);

		Peasant.HealDamage(ALTER_HEALTH_CHURCH, none, class'DamageType');
		Peasant.AlterThirst(ALTER_THIRST_CHURCH);//theese should be a function of the church's zeal
		Peasant.AlterHunger(ALTER_HUNGER_CHURCH);
		Peasant.AlterCorruption(ALTER_CORRUPTION_CHURCH);
		`log(name @ ":" @ "gets a blessing" @ Peasant.StatsToString());
	}
Inside:
	//TODO Inside Church waiting for mass state here.
	goto 'AttendingMass';
AttendingMass:
	GetBlessing();
	Sleep(1);
	GetBlessing();
	Sleep(1);
	goto 'GoOutside';
RepportHorsemen:
	MoveTo(ApocBuilding(Destination).Location);
	StopLatentExecution();
	//`log(name @ ":" @ Pawn.Name @ "is repporting the location of horsemen to the church");
	Sleep(1);
	GetBlessing();
	Sleep(1);
	goto 'GoOutside';
}

state Strolling
{
	function SetDestination()
	{
		Destination = FindRandomActor();
		//`log(name @ ":" @ Pawn.Name @ "decided to stroll and targets the strolling destination" @ Destination.Name @ ApocPeasant(Pawn).StatsToString());
	}
Begin:
	RefreshTasks();
	WaitForLanding();
	SetDestination();
	PushState('Walking');
	GotoState(NextTask);
}

state RunAway
{
	event PushedState()
	{
		super.PushedState();
		//`log(name @ ":" @ Pawn.Name @ "has spotted the horsemen and is runing away!");
		Pawn.bIsWalking = false;
	}
	event PoppedState()
	{
		super.PoppedState();
		`log(name @ ":" @ Pawn.Name @ "has alerted the church, resuming with" @ CurrentTask);
		Enemy = none;
		Destination = PreviousDestination;
		PreviousDestination = none;
		Pawn.bIsWalking = true;
	}

	function SetDestination()
	{
		PreviousDestination = Destination;
		Destination = FindNearestTargetOfType('ApocChurch');
	}

	function SetNextDestination()
	{
		NextDest = GeneratePathToActor(Destination, INTERACTION_DISTANCE);
	}

Begin:
	WaitForLanding();
	SetDestination();
	goto 'Run';
Run:
	WaitForLanding();
	if(VSize(Destination.GetNavPoint() - Pawn.Location) < INTERACTION_DISTANCE)
	{		
		goto 'Report';
	}
	SetNextDestination();
	MoveTo(NextDest);
	//// TODO Fjern debug
	//DrawDebugLine(Pawn.Location, NextDest, 255, 255, 0, true);
	goto 'Run';
Report:
	PushState('InsideChurch', 'RepportHorsemen');
	PopState(false);
}
