class ApocPeasantHouse extends ApocBuilding
	placeable;

//Stocks
var(Apocalypse) int MaxCapacity;
var(Apocalypse) int Food;
var(Apocalypse) int Water;

DefaultProperties
{
	MaxInhabitants = 1;
	IsFull = false;
	MaxCapacity = 50;
	Food = 0;
	Water = 0;
}

event PreBeginPlay()
{
	super.PreBeginPlay();
}


function SetNavPoint()
{
	local Vector rot;
	local Vector pos;
	local Rotator uRot;
	local NavPoint np;
	
	uRot.Yaw = (16384 * 3);
	uRot += Rotation;
	pos = Location;
	
	rot = Vector(uRot);

	`log("House is located at: " @pos @"and has rotation" @rot);
	pos = pos + (rot * 120);

	pos.Z += 50;
	np.isOccupied = false;
	np.navPoint = pos;
	NavPoints.AddItem(np);
}

event Tick(float DeltaTime)
{
	//DrawDebugPoint(GetNavPoint() ,30, MakeLinearColor(255, 0, 0, 128), false);
}

/**
 * Returns wether the changed value was within the limits.
 */
function bool AlterWater(int change)
{
	local bool WithinLimits;
	local int TempWater;
	TempWater = Water + change;
	WithinLimits = (0 <= TempWater) && (TempWater <= MaxCapacity);
	//`log("Water stock changes with" @ change @ "from:" @ Water @ "to" @ TempWater @ "Is this within the limits:" @ WithinLimits);
	Water += change;
	Water = Max(Water, 0);
	Water = Min(MaxCapacity, Water);
	return WithinLimits;
}

/**
 * Returns wether the changed value was within the limits.
 */
function bool AlterFood(int change)
{
	local bool WithinLimits;
	local int TempFood;
	TempFood = Food + change;
	WithinLimits = (0 <= TempFood) && (TempFood <= MaxCapacity);
	//`log("Food stock changes with" @ change @ "from:" @ Food @ "to" @ TempFood @ "Is this within the limits:" @ WithinLimits);
	Food += change;
	Food = Max(Food, 0);
	Food = Min(MaxCapacity, Food);
	return WithinLimits;
}
