class ApocPlayer extends ApocPawn // 
	config(Game)
	//implements(Interface_NavMeshPathObstacle) // Native asshole interface. Fr ikke brukt dette eller derivatklassene(brushes + NavMeshObstacle) fr Epic pner opp.
	placeable;

const SPEED_PERCENTAGE = 0.01f;

var(Apocalypse) float RotationInterpSpeed;
var bool IsInAttackSwing;
var Vector PrevLocation;
var bool DebugSpeed;
var bool DebugDraw;

DefaultProperties
{
	AirControl = 1.0f;
	RotationInterpSpeed = 6.5f;
	IsInAttackSwing = false;

	bBlockActors = true;
	bBlocksNavigation = true;

	//Speed variables must be set here, and with constants(no formulaes in DefaultProperties) in order to work properly
	// TODO set these to proper values when debug is finished.
						//UDK defaults:
						// Divisors:  Common | Walking | Extra |
	GroundSpeed = 300;  //     600 =  5*5*2 *    2    * 3*2   = Base
	AirSpeed    = 300;  //     600 =  5*5*2 *    2    * 3*2   = GroundSpeed
	WaterSpeed  = 150;  //     300 =  5*5*2 *    2    * 3     = GroundSpeed/2
	LadderSpeed = 100;  //     200 =  5*5*2 *    2    * 2     = GroundSpeed/3



	// LOG VARIABLER. Sl av/p debug logging med disse
	DebugDraw = false;
	DebugSpeed = false;

}

event PostBeginPlay()
{
	super.PostBeginPlay();

	if (DebugDraw)
	{
		`log(name @ "GroundSpeed is" @ GroundSpeed);
		`log(name @ "AirSpeed is" @ AirSpeed);
		`log(name @ "WaterSpeed is" @ WaterSpeed);
		`log(name @ "LadderSpeed is" @ LadderSpeed);
		SetTimer(1.0f/60.0f, true, 'DrawDebug');
	}
}

function DrawDebug()
{
	DrawDebugCylinder(Location, Location, AVOID_DISTANCE, 360, 255, 0, 0, false);

	if (DebugSpeed)
	{
		`log(name @ "speed is" @ VSize(Location - PrevLocation)/(1.0f/60.0f) @ "Unreal units per second");
		PrevLocation = Location;
	}
}

/** Called from the PlayerController's PlayerMove function, updates the Rotation to a new destination. */
function UpdateRotation(float DeltaTime, Vector Direction)
{
	Direction.Z = 0; //no Actor pitch in our game.

	if(VSize(Direction) > 0) //only set a valid rotation, otherwise just keep the old one.
		SetRotation(RInterpTo(Rotation, Rotator(Direction),DeltaTime,RotationInterpSpeed));  //use interpolation to smoothly look towards this direction over time (this function is called every frame when moving)
}

state MeleeAttacking
{
	event Tick(float DeltaTime)
	{
		if(IsInAttackSwing){
			ApocWeaponScythe(Weapon).Slash();			
		}
	}
Begin:
	PlayCustomAnim('Death_attack', 1.0, 0.1, 0.1, false);
	
}

event MeleeSwingStart()
{
	IsInAttackSwing = true;
	WorldInfo.TimeDilation = 0.2;
}

event MeleeSwingEnd()
{
	IsInAttackSwing = false;
	WorldInfo.TimeDilation = 1.0;
}
