class ApocWeapon extends Weapon;
var(Apocalypse) name WeaponAttachmentSocketName;

simulated function Activate()
{
	super.Activate();
	AttachWeaponTo(Instigator.Mesh,WeaponAttachmentSocketName);
}

simulated function AttachWeaponTo(SkeletalMeshComponent MeshCpnt, optional Name SocketName)
{
	local ApocPawn P;

	super.AttachWeaponTo(MeshCpnt, SocketName);

	P = ApocPawn(Instigator);
	Mesh.SetLightEnvironment(P.LightEnvironment); //share the light environment
	Mesh.SetShadowParent(P.Mesh); //and the shadows
	
	
	if(SocketName != 'none')
	{
		SetBase(P,,P.Mesh,SocketName); //base our actor on the pawn
		P.Mesh.AttachComponentToSocket(Mesh,SocketName); //and attach our skeletalmesh component to our pawn's socket
	}
	else
		SetBase(P); //or just base on it

	//unhide the weapon when active
	SetHidden(false);
}

//Firing here, do nothing ATM
simulated function CustomFire()
{
	`log("Unimplemented custom fire");
}


simulated function bool HasAmmo( byte FireModeNum, optional int Amount )
{
	return true; //no ammo in Dungeon Defense!
}
simulated function bool HasAnyAmmo()
{
	return true; //no ammo in Dungeon Defense!
}


DefaultProperties
{
	Begin Object Class=SkeletalMeshComponent Name=MySkeletalMeshComponent
		Scale=1.0
		AlwaysLoadOnClient=true
		AlwaysLoadOnServer=true
		CastShadow=true
		BlockRigidBody=FALSE
		bCastDynamicShadow=true
		bAcceptsDecals=false
		bAcceptsDecalsDuringGameplay=false
		bAcceptsDynamicDecals=false
	End Object
	Components.Add(MySkeletalMeshComponent)
	Mesh=MySkeletalMeshComponent

	WeaponFireTypes[0]=EWFT_Custom
	FiringStatesArray[0]=WeaponFiring

	FireInterval[0]=0.5
	WeaponAttachmentSocketName = WeaponPoint
	bDropOnDeath=false

	
}
