class ApocWeaponScythe extends ApocWeapon;

var transient float LastReleasedTime;
var(Apocalypse) EmitterSpawnable Emitter;


simulated function BeginFire(Byte FireModeNum)
{
	//start charge here
	super.BeginFire(FireModeNum);
}
simulated function EndFire(Byte FireModeNum)
{
	//stop charge here
	GotoState('Active');
	super.EndFire(FireModeNum);
}

simulated state Active
{
	/** Initialize the weapon as being active and ready to go. */
	simulated event BeginState(Name PreviousStateName)
	{
		// Cache a reference to the AI controller
		if (Role == ROLE_Authority)
		{
			CacheAIController();
		}
		// Check to see if we need to go down
   		if( bWeaponPutDown )
		{
			PutDownWeapon();
		}
		else if ( !HasAnyAmmo() )
		{
			WeaponEmpty();
		}
		//removed automatic firing upon entering active state
	}

	/** Override BeginFire so that it will enter the firing state right away. */
	simulated function BeginFire(byte FireModeNum)
	{
		if( !bDeleteMe && Instigator != None )
		{
			Global.BeginFire(FireModeNum);
			//if(`TimeSince(LastReleasedTime) > FireInterval[0])
				SendToFiringState(0);
		}
	}

	event Tick(float DeltaTime)
	{
		super.Tick(DeltaTime);

		//if(`TimeSince(LastReleasedTime) > FireInterval[0])
	//			SendToFiringState(0);
	}
}

/** Magic Staff's in this state while holding down the Fire button, charges up until release */
simulated state WeaponFiring
{
	simulated event BeginState( Name PreviousStateName )
	{

		//shoot it!
		//Spill deilig pelvic thrust anim
		//`log("Begin Weapon Firing State!");
		super.BeginState(PreviousStateName);
		TimeWeaponFiring( CurrentFireMode );
		Instigator.GotoState('MeleeAttacking');
		LastReleasedTime=WorldInfo.TimeSeconds;
		
		
	}

	simulated function RefireCheckTimer()
	{
		// if switching to another weapon, abort firing and put down right away
		if( bWeaponPutDown )
		{
			PutDownWeapon();
			return;
		}

		return;
	}

	event Tick(float DeltaTime)
	{
		super.Tick(DeltaTime);	
		/*if(AnimNodeSlot(Instigator.Mesh.FindAnimNode('FullBodySlot')).GetPlayedAnimation() == 'Death_attack')
			FireAmmunition();*/

	}

	/** Released weapon fire */
	simulated event EndState( Name NextStateName )
	{
		super.EndState(NextStateName);
	}
}

simulated function CustomFire()
{
}

simulated function Slash()
{
	local Vector            StartTrace, EndTrace;
	local Array<ImpactInfo>	ImpactList;
	local ImpactInfo		RealImpact;
	

	// define range to use for CalcWeaponFire()
		
	StartTrace = ApocPlayerController(Instigator.Controller).PawnEyeLocation - vect(0, 0, 50);
	SkeletalMeshComponent(Mesh).GetSocketWorldLocationAndRotation('ScytheHandle', StartTrace);
	SkeletalMeshComponent(Mesh).GetSocketWorldLocationAndRotation('ScytheTip', EndTrace); 
	//EndTrace = StartTrace + Vector(Instigator.Rotation) * WeaponRange;
	//DrawDebugLine(StartTrace, EndTrace, 255, 0, 0, true);

	// Perform shot
	RealImpact = CalcWeaponFire(StartTrace, EndTrace, ImpactList, vect(100,50,1));
	
	if(RealImpact.HitActor != none) {
		//`log("HIT ACTOR" @ RealImpact.HitActor.Name);
		if(ApocPawn(RealImpact.HitActor) != none) {
			//`log("HIT APOCPAWN" @ RealImpact.HitActor.Name);
			ApocPawn(RealImpact.HitActor).TakeDamage(100000, Instigator.Controller, RealImpact.HitLocation, RealImpact.RayDir, class'DamageType', RealImpact.HitInfo, Instigator);		
		}
		Spawn(Emitter.Class,,,RealImpact.HitLocation,Rotator(RealImpact.HitNormal),Emitter,true);
	}
}

simulated function bool ShouldRefire()
{
	return false;
}

DefaultProperties
{
	WeaponRange = 200;
	Spread[0]=0;
}
