class main extends GameInfo;

/** What Pawn Archetype to use for the Player's Pawn -- 
 *  note this is NOT Dynamically Loaded, so it must be referenced somewhere in script, or in the gameplay level, in order
 *  for it to be correctly spawned. */
var string PlayerPawnArchetypeName;
/** What PlayerController Archetype to use for the Player's Controller -- 
 *  note this is NOT Dynamically Loaded, so it must be referenced somewhere in script, or in the gameplay level, in order
 *  for it to be correctly spawned. */
var string PlayerControllerArchetypeName;

var bool DisablePlayerInput;

/** Optional Direct Reference to our Default Pawn Archetype, so it'll be cooked into the base script package (could alternatively reference directly in the maps) */
var Pawn DefaultPawnArchetype;
/** Optional Direct Reference to our Default Controller Archetype, so it'll be cooked into the base script package (could alternatively reference directly in the maps) */
var PlayerController PlayerControllerArchetype;

var transient array<Actor> TargetableActors;

/** modified to spawn from archetype template, rather than just the class */
function Pawn SpawnDefaultPawnFor(Controller NewPlayer, NavigationPoint StartSpot)
{
	local Rotator StartRotation;
	local Pawn ResultPawn;
	local Pawn PawnArchetypeToUse;

	// don't allow pawn to be spawned with any pitch or roll
	StartRotation.Yaw = StartSpot.Rotation.Yaw;

	PawnArchetypeToUse = Pawn(DynamicLoadObject(PlayerPawnArchetypeName,class'ApocPlayer'));

	ResultPawn = Spawn(PawnArchetypeToUse.Class,,,StartSpot.Location,StartRotation,PawnArchetypeToUse,true);
	if ( ResultPawn == None )
	{
		`log("Couldn't spawn player of type "$PawnArchetypeToUse.Class$" at "$StartSpot);
	}
	return ResultPawn;
}

/** modified to spawn from archetype template, rather than just the class */
function PlayerController SpawnPlayerController(vector SpawnLocation, rotator SpawnRotation)
{
	local PlayerController ControllerArchetypeToUse;
	ControllerArchetypeToUse = PlayerController(DynamicLoadObject(PlayerControllerArchetypeName,class'PlayerController'));
	return Spawn(ControllerArchetypeToUse.Class,,, SpawnLocation, SpawnRotation,ControllerArchetypeToUse);
}

DefaultProperties
{
	PlayerPawnArchetypeName = "ApocArchetypes.PlayerCharacter";
	PlayerControllerArchetypeName = "ApocArchetypes.PlayerController";
	PlayerControllerArchetype=ApocPlayerController'ApocArchetypes.PlayerController'
	DefaultPawnArchetype=ApocPlayer'ApocArchetypes.PlayerCharacter'

	bDelayedStart = false;
	//DefaultPawnClass=class'Apocalypse.ApocPawn'
	//PlayerControllerClass=class'Apocalypse.ApocPlayerController'
	HUDType = class'ApocHud';
	DisablePlayerInput = false;
}

event PostBeginPlay()
{
	// TODO Remy:: Legge inn TeamInfo p kontrollere her eller opprette subklasse av WorldInfo klassen.
	// Temporary on hold til Pesant DecisionTree er oppe.
	//local TeamInfo HorsemenTeam;
	//local TeamInfo VillageTeam;

	super.PostBeginPlay();

	//VillageTeam = Spawn(class'TeamInfo');
	//VillageTeam.TeamName = "VillageTeam";
	//VillageTeam.TeamIndex = 1;
//  Det er i WorldInfo vi har liste over controllere og GameInfo/TeamInfo
//	WorldInfo.AllControllers
//	WorldInfo.Game.
//	`log("");
}